<?php

namespace WPAI;

class WPAI_Ad_Spots {

    private $spots;

    public function __construct() {
        $this->spots = [];
    }

    public function total_cnt() {
        return array_sum($this->spots);
    }

    public function is_available($spot_name, $behavior, $max) {
        if ($behavior === 'skip-on-max-in-spot') {
            if (isset($this->spots[$spot_name]) && $this->spots[$spot_name] >= intval($max)) {
                return false;
            }
        } elseif ($behavior === 'skip-on-max-total') {
            if ($this->total_cnt() >= $max) {
                return false;
            }
        }
        return true;
    }

    public function inc_spots($spot_name) {
        if (isset($this->spots[$spot_name])) {
            $this->spots[$spot_name]++;
        } else {
            $this->spots[$spot_name] = 1;
        }
    }

}

?>