<?php

namespace WPAI;

class wpai_widget extends \WP_Widget {

    function __construct() {
        parent::__construct(
                'wpai_widget',
                __('WP Ad Inserter Widget', 'wpai_widget_domain'),
                array('description' => __('WP Ad Inserter Widget', 'wpai_widget_domain'),)
        );
    }

    public function widget($args, $instance) {
        $title = apply_filters('widget_title', $instance['title']);
        echo $args['before_widget'];
        if (!empty($title)) {
            echo $args['before_title'] . $title . $args['after_title'];
        }
        global $wpai;
        foreach ($wpai->get_campaigns() as $campaign) {
            if (($campaign['position'] ?? '') === 'widget') {
                echo $wpai->prepare_ad($campaign);
            }
        }
        echo $args['after_widget'];
    }

    public function form($instance) {
        if (isset($instance['title'])) {
            $title = $instance['title'];
        } else {
            $title = __('New title', 'wpai_widget_domain');
        }
        ?>
        <p>
            <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" />
        </p>
        <?php
    }

    public function update($new_instance, $old_instance) {
        $instance = array();
        $instance['title'] = (!empty($new_instance['title']) ) ? strip_tags($new_instance['title']) : '';
        return $instance;
    }

}

function wpai_load_widget() {
    register_widget(__NAMESPACE__ . '\wpai_widget');
}

add_action('widgets_init', __NAMESPACE__ . '\wpai_load_widget');
?>